## dde-network-core 1.0.7.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(dde-network-core)

add_subdirectory("src")
add_subdirectory("dcc-network-plugin")
add_subdirectory("tests")
add_subdirectory("example")
add_subdirectory("dock-network-plugin")
add_subdirectory("dde-network-dialog")
add_subdirectory("dss-network-plugin")
add_subdirectory("dss_example")
add_subdirectory("dock-example")

=== dcc-network-plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dcc-network-plugin")

project(${PLUGIN_NAME})

# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)

# 指定所有源码文件
file(GLOB_RECURSE SRCS "*.h"
    "*.cpp"
    "icons/*"
    "../src/*.h"
    "../src/*.cpp"
    "icons/dcc-network-plugin.qrc"
    "translations/translations.qrc"
    "icons/actions/*.svg"
    "icons/icons/*.svg")

# 指定要用到的库
find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(DdeControlCenter REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)

#pkg_check_modules(DDE-Network-Core REQUIRED dde-network-core)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

file(GLOB TS_FILES "translations/*.ts")

qt5_add_translation(QM_FILES ${TS_FILES})

add_custom_target(translations ALL DEPENDS ${QM_FILES})

# 新增一个编译目标
# 这里使用命令 add_library 来表示本项目要生成一个库文件目标，
add_library(${PLUGIN_NAME} SHARED ${SRCS})

# 设置目标要使用的 include 目录，即头文件目录
# 变量 ${DtkWidget_INCLUDE_DIRS} 是在前面执行 find_package 命令时引入的
# 当出现编译失败提示找不到某些库的头文件时应该检查此处是否将所有需要的头文件都包含了
target_include_directories(${PLUGIN_NAME} PUBLIC
    ../src
    ../src/realize
    ${Qt5Widgets_INCLUDE_DIRS}
    ${DtkWidget_INCLUDE_DIRS}
    ${DdeControlCenter_INCLUDE_DIR}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
#    ${DDE-Network-Core_INCLUDE_DIRS}
)

# 设置目标要使用的链接库
# 变量 ${DtkWidget_LIBRARIES} 和 ${Qt5Widgets_LIBRARIES} 是在前面执行 find_package 命令时引入的
# 当出现运行时错误提示某些符号没有定义时应该检查此处是否将所有用的库都写在了这里
target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${Qt5Widgets_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${DdeControlCenter_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${KF5_QT_LIBRARIES}
    ${Qt5Network_LIBRARIES}
#    ${DDE-Network-Core_LIBRARIES}
)

# 设置安装路径的前缀(默认为"/usr/local")
set(CMAKE_INSTALL_PREFIX "/usr")

# 设置执行 make install 时哪个目标应该被 install 到哪个位置
install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-control-center/modules)

# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION share/${PLUGIN_NAME}/translations)

=== dss-network-plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dss-network-plugin")

project(${PLUGIN_NAME})

# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)

file(GLOB_RECURSE SRCS "*.h" "*.cpp"  "../src/*.h" "../src/*.cpp" "../common-plugin/*.h" "../common-plugin/*.cpp")

find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
find_package(DdeSessionShell REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)

file(GLOB TS_FILES "translations/*.ts")
qt5_add_translation(QM_FILES ${TS_FILES})
add_custom_target(${TARGET_NAME}_language ALL DEPENDS ${QM_FILES})

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} ../common-plugin/network.qrc)

set(NETWORKINTERFACE "../src")
list(REMOVE_ITEM NETWORKINTERFACE "utils.h")

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

target_include_directories(${PLUGIN_NAME} PUBLIC
    ${NETWORKINTERFACE}
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    #${DDE-Network-Core_INCLUDE_DIRS}
    ${DDESESSIONSHELL_INCLUDE_DIR}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS}
    "../common-plugin/"
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${QGSettings_LIBRARIES}
    #${DDE-Network-Core_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${KF5_QT_LIBRARIES}
    ${Qt5Network_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION /lib/dde-session-shell/modules)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION /usr/share/${PLUGIN_NAME}/translations)
install(FILES 10-network-manager.pkla DESTINATION /var/lib/polkit-1/localauthority/10-vendor.d)

=== debian/changelog ===
dde-network-core (1.0.7.1-1) unstable; urgency=medium

  * update

 -- donghualin <donghualin@uniontech.com>  Tue, 22 Feb 2022 10:13:12 +0800

dde-network-core (1.0.0.1) stable; urgency=medium

 -- donghualin <donghualin@uniontech.com> (1.0.0.1) stable; urgency=medium

## dde-network-core 1.0.34

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,11 @@
 cmake_minimum_required(VERSION 3.7)
 
 project(dde-network-core)
+
+# 增加安全编译参数
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
+set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")
 
 add_subdirectory("src")
 add_subdirectory("dcc-network-plugin")

=== dde-network-dialog/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(TARGET_NAME "dde-network-dialog")

project(${TARGET_NAME})

# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)

file(GLOB_RECURSE SRCS "*.h" "*.cpp" "../src/*.h" "../src/*.cpp")

find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

file(GLOB TS_FILES "translations/*.ts")
qt5_add_translation(QM_FILES ${TS_FILES})
add_custom_target(${TARGET_NAME}_language ALL DEPENDS ${QM_FILES})

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_executable(${TARGET_NAME} ${SRCS} network.qrc)

set(NETWORKINTERFACE "../src")
list(REMOVE_ITEM NETWORKINTERFACE "utils.h")

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

target_include_directories(${TARGET_NAME} PUBLIC
    ${NETWORKINTERFACE}
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    #${DDE-Network-Core_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS}
)

target_link_libraries(${TARGET_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${QGSettings_LIBRARIES}
    #${DDE-Network-Core_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${KF5_QT_LIBRARIES}
    ${Qt5Network_LIBRARIES}
)

install(TARGETS ${TARGET_NAME} DESTINATION /usr/bin)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION /usr/share/${TARGET_NAME}/translations)

=== dock-example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(dock_example)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_PREFIX_PATH $ENV{Qt5_DIR})
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(DdeControlCenter REQUIRED)
find_package(Qt5 COMPONENTS Core DBus Network REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DdeDock REQUIRED)

aux_source_directory(../dock-network-plugin DOCKPLUGINDIR)
aux_source_directory(../common-plugin COMMONPLUGINS)
aux_source_directory(../common-plugin/widgets COMMONPLUGINWIDGET)
aux_source_directory(../common-plugin/item COMMONPLUGINITEM)
aux_source_directory(../src NETWORKDIR)
aux_source_directory(../src/realize REALIZEDIR)
aux_source_directory(. COMPILEFILES)
file(GLOB_RECURSE QRCFILES "../common-plugin/network.qrc"
    "../common-plugin/resources/common/*.svg"
    "../common-plugin/resources/wired/*.svg"
    "../common-plugin/resources/wireless/*.svg"
    "../common-plugin/resources/wireless6/*.svg")

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

add_executable(${PROJECT_NAME}
    ${COMPILEFILES}
    ${NETWORKDIR}
    ${DOCKPLUGINDIR}
    ${COMMONPLUGINS}
    ${COMMONPLUGINWIDGET}
    ${COMMONPLUGINITEM}
    ${REALIZEDIR}
    ${QRCFILES})

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

foreach(LETTER ${TRY_KF5_LIBRARIES})
    if (NOT KF5_QT_LIBRARIES)
        get_target_property(KF5_QT_LIBRARIES KF5::NetworkManagerQt ${LETTER})
    endif()
endforeach()

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

target_include_directories(${PROJECT_NAME} PUBLIC
    ../src
    ../src/realize
    ../dock-network-plugin
    ../common-plugin
    ../common-plugin/widgets
    ../common-plugin/item
    ../common-plugin/resources/common/
    ../common-plugin/resources/wired/
    ../common-plugin/resources/wireless/
    ${DdeControlCenter_INCLUDE_DIR}
    ${DDE_DOCK_INCLUDE_DIR}
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${Qt5Widget_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${LibNM_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS})

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${DdeControlCenter_LIBRARIES}
    ${DDE_DOCK_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${Qt5Core_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${LibNM_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${KF5_QT_LIBRARIES})

add_custom_command(
    OUTPUT path.pb.cc path.pb.h
    COMMAND protoc
    ARGS --cpp_out . ${CMAKE_CURRENT_SOURCE_DIR}/path.proto -I ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS path.proto)

=== dock-network-plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dock-network-plugin")

project(${PLUGIN_NAME})

# 启用 qt moc 的支持
set(CMAKE_AUTOMOC ON)
# 启用 qrc 资源文件的支持
set(CMAKE_AUTORCC ON)

file(GLOB_RECURSE SRCS "*.h" "*.cpp" "item/*.h" "item/*.cpp" "../src/*.h" "../src/*.cpp" "../common-plugin/*.h" "../common-plugin/*.cpp")

find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DdeDock REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(DDE-Dock REQUIRED dde-dock)

file(GLOB TS_FILES "translations/*.ts")
qt5_add_translation(QM_FILES ${TS_FILES})
add_custom_target(language ALL DEPENDS ${QM_FILES})

add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
add_library(${PLUGIN_NAME} SHARED ${SRCS} ../common-plugin/network.qrc)

set(NETWORKINTERFACE "../src")
list(REMOVE_ITEM NETWORKINTERFACE "utils.h")

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

target_include_directories(${PLUGIN_NAME} PUBLIC
    ${NETWORKINTERFACE}
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    #${DDE-Network-Core_INCLUDE_DIRS}
    ${DDE_DOCK_INCLUDE_DIR}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS}
    "../common-plugin/"
)

target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${QGSettings_LIBRARIES}
    #${DDE-Network-Core_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${KF5_QT_LIBRARIES}
    ${Qt5Network_LIBRARIES}
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION /usr/lib/dde-dock/plugins/system-trays)
# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION /usr/share/${PLUGIN_NAME}/translations)

=== dss_example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(dss_example)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_PREFIX_PATH $ENV{Qt5_DIR})
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(DdeControlCenter REQUIRED)
find_package(Qt5 COMPONENTS Core DBus Network REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DdeDock REQUIRED)
find_package(DdeSessionShell REQUIRED)

aux_source_directory(../dss-network-plugin DSSPLUGINTHEMES)
aux_source_directory(../dss-network-plugin/notification DSSPLUGINNOTIFICATION)
aux_source_directory(../common-plugin COMMONPLUGINS)
aux_source_directory(../common-plugin/widgets COMMONPLUGINWIDGET)
aux_source_directory(../common-plugin/item COMMONPLUGINITEM)
aux_source_directory(../src NETWORKDIR)
aux_source_directory(../src/realize REALIZEDIR)
aux_source_directory(. COMPILEFILES)

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

#set(COMPILEFILES ./*.h ./*.cpp)

add_executable(${PROJECT_NAME}
    ${COMPILEFILES}
    ${NETWORKDIR}
    ${DSSPLUGINTHEMES}
    ${DSSPLUGINNOTIFICATION}
    ${COMMONPLUGINS}
    ${COMMONPLUGINWIDGET}
    ${COMMONPLUGINITEM}
    ${REALIZEDIR})

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

foreach(LETTER ${TRY_KF5_LIBRARIES})
    if (NOT KF5_QT_LIBRARIES)
        get_target_property(KF5_QT_LIBRARIES KF5::NetworkManagerQt ${LETTER})
    endif()
endforeach()

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

target_include_directories(${PROJECT_NAME} PUBLIC
    ../src
    ../src/realize
    ../dss-network-plugin
    ../common-plugin
    ../common-plugin/widgets
    ../common-plugin/item
    ../dss-network-plugin/interface
    ${DdeControlCenter_INCLUDE_DIR}
    ${DDE_DOCK_INCLUDE_DIR}
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${Qt5Widget_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${LibNM_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS})

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${DdeControlCenter_LIBRARIES}
    ${DDE_DOCK_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${Qt5Core_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${LibNM_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${KF5_QT_LIBRARIES})

add_custom_command(
    OUTPUT path.pb.cc path.pb.h
    COMMAND protoc
    ARGS --cpp_out . ${CMAKE_CURRENT_SOURCE_DIR}/path.proto -I ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS path.proto)

=== example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(example)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_PREFIX_PATH $ENV{Qt5_DIR})
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(DdeControlCenter REQUIRED)

aux_source_directory(../dcc-network-plugin DCCPLUGINDIR)
aux_source_directory(../dcc-network-plugin/window DCCPLUGINWINDOWDIR)
aux_source_directory(../dcc-network-plugin/sections DCCPLUGINSECTIONS)
aux_source_directory(../dcc-network-plugin/sections/vpn DCCPLUGINSECTIONSVPN)
aux_source_directory(../dcc-network-plugin/settings DCCPLUGINSETTINGS)
aux_source_directory(../dcc-network-plugin/settings/vpn DCCPLUGINVPNSETTINGS)
aux_source_directory(../dcc-network-plugin/themes DCCPLUGINTHEMES)
aux_source_directory(../src NETWORKDIR)
aux_source_directory(../src/realize REALIZEDIR)

file(GLOB_RECURSE QRCFILE "./example.qrc"
    "../dcc-network-plugin/icons/dcc-network-plugin.qrc"
    "../dcc-network-plugin/icons/actions/*.svg"
    "../dcc-network-plugin/icons/icons/*.svg")

set(COMPILEFILES
    ./networkhandler.h
    ./networkhandler.cpp
    ./main.cpp
    ./dccplugintestwidget.h
    ./dccplugintestwidget.cpp)

#list(REMOVE_ITEM NETWORKDIR "../dde-network-core/debian")

add_executable(${PROJECT_NAME}
    ${COMPILEFILES}
    ${DCCPLUGINDIR}
    ${DCCPLUGINWINDOWDIR}
    ${NETWORKDIR}
    ${DCCPLUGINSECTIONS}
    ${DCCPLUGINSECTIONSVPN}
    ${DCCPLUGINSETTINGS}
    ${DCCPLUGINVPNSETTINGS}
    ${DCCPLUGINTHEMES}
    ${REALIZEDIR}
    ${QRCFILE})

find_package(Qt5 COMPONENTS Core DBus Network REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
find_package(DtkWidget REQUIRED)

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

foreach(LETTER ${TRY_KF5_LIBRARIES})
    if (NOT KF5_QT_LIBRARIES)
        get_target_property(KF5_QT_LIBRARIES KF5::NetworkManagerQt ${LETTER})
    endif()
endforeach()

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

target_include_directories(${PROJECT_NAME} PUBLIC
    ../src
    ../src/realize
    ../dcc-network-plugin
    ${DdeControlCenter_INCLUDE_DIR}
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${Qt5Widget_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${LibNM_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS})

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${DdeControlCenter_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${Qt5Core_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${LibNM_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${KF5_QT_LIBRARIES})

add_custom_command(
    OUTPUT path.pb.cc path.pb.h
    COMMAND protoc
    ARGS --cpp_out . ${CMAKE_CURRENT_SOURCE_DIR}/path.proto -I ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS path.proto)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(dde-network-core)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_PREFIX_PATH $ENV{Qt5_DIR})

file(GLOB_RECURSE SOURCEFILES "*.h" "*.cpp")
add_library(${PROJECT_NAME} SHARED ${SOURCEFILES})

find_package(Qt5 COMPONENTS Core DBus Network REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    realize
    ${Qt5DBus_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${LibNM_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS})

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${Qt5Core_LIBRARIES}
    ${LibNM_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${KF5_QT_LIBRARIES})

configure_file(dde-network-core.pc.in ../dde-network-core.pc @ONLY)

set(INTERFACEFILES
    dslcontroller.h
    hotspotcontroller.h
    networkconst.h
    networkcontroller.h
    networkdetails.h
    networkdevicebase.h
    proxycontroller.h
    vpncontroller.h
    wireddevice.h
    wirelessdevice.h)

set(CMAKE_INSTALL_PREFIX "/usr")

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets LIBRARY DESTINATION lib)
install(FILES ${CMAKE_BINARY_DIR}/dde-network-core.pc DESTINATION lib/pkgconfig)
install(FILES ${INTERFACEFILES} DESTINATION include/libddenetworkcore)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project(tst-dde-network)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_PREFIX_PATH $ENV{Qt5_DIR})
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(Qt5 COMPONENTS Core DBus Network REQUIRED)
find_package(GTest REQUIRED)
find_package(KF5NetworkManagerQt REQUIRED)
find_package(Qt5Widgets REQUIRED)

get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)

foreach(LETTER ${TRY_KF5_LIBRARIES})
    if (NOT KF5_QT_LIBRARIES)
        get_target_property(KF5_QT_LIBRARIES KF5::NetworkManagerQt ${LETTER})
    endif()
endforeach()

# 用于测试覆盖率的编译条件
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_definitions(-D SANITIZER_CHECK)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2")
endif()

if (NOT KF5_QT_LIBRARIES)
    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
endif()

set(TRY_KF5_LIBRARIES
IMPORTED_LOCATION_DEBIAN
IMPORTED_LOCATION_NOCONFIG
)

aux_source_directory(. FILES)
aux_source_directory(../src NETWORKDIR)
aux_source_directory(../src/realize REALIZEDIR)

add_executable(${PROJECT_NAME} ${FILES} ${NETWORKDIR} ${REALIZEDIR})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${LibNM_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    ${Qt5Widget_INCLUDE_DIRS}
    ${KF5_QT_INCLUDE_DIRS}
    ../src)

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${Qt5Core_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${LibNM_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    ${Qt5Network_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${KF5_QT_LIBRARIES}
    -lpthread
    -lm)

=== debian/changelog ===
dde-network-core (1.0.34-1) unstable; urgency=medium

  * update

 -- donghualin <donghualin@uniontech.com>  Mon, 16 May 2022 16:42:08 +0800

=== debian/control ===
Source: dde-network-core
Section: lib
Priority: optional
Maintainer: donghualin <donghualin@uniontech.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libdframeworkdbus-dev (>= 1.0.2),
               libgsettings-qt-dev,
               pkg-config,
               qtbase5-dev,
               qttools5-dev-tools,
               libgtest-dev,
               libkf5networkmanagerqt-dev,
               libdtkwidget-dev,
               dde-control-center-dev,
               dde-dock-dev,
               dde-session-shell-dev,
               qttools5-dev
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://gerrit.uniontech.com/admin/repos/dde-network-core
Vcs-Browser: https://gerrit.uniontech.com/admin/repos/dde-network-core

Package: libdde-network-core
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},
Description: the library of network
 libdde-network-core module

Package: libdde-network-core-dev
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},
Description: the interface of networkcode,used for developers
 libdde-network-core-dev module

Package: dcc-network-plugin
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},
Description: the plugin of network for dde control center
 dcc-network-plugin module

Package: dock-network-plugin
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},
Description: the plugin of network for dde-dock
 dock-plugin module

Package: dde-network-dialog
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},
Description: the executable of network
 dde-network-dialog module

Package: dss-network-plugin
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends},
Description: the plugin of network for dde-lock
 dss-network-plugin module

## dde-network-core 1.0.47

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,9 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
 set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")
+
+set(DDE-Network-Core_INCLUDE_DIRS  "${CMAKE_SOURCE_DIR}/src")
+set(DDE-Network-Core_LIBRARIES  dde-network-core)
 
 add_subdirectory("src")
 add_subdirectory("dcc-network-plugin")

=== dcc-network-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -13,8 +13,6 @@
 file(GLOB_RECURSE SRCS "*.h"
     "*.cpp"
     "icons/*"
-    "../src/*.h"
-    "../src/*.cpp"
     "icons/dcc-network-plugin.qrc"
     "translations/translations.qrc"
     "icons/actions/*.svg"
@@ -56,8 +54,6 @@
 # 变量 ${DtkWidget_INCLUDE_DIRS} 是在前面执行 find_package 命令时引入的
 # 当出现编译失败提示找不到某些库的头文件时应该检查此处是否将所有需要的头文件都包含了
 target_include_directories(${PLUGIN_NAME} PUBLIC
-    ../src
-    ../src/realize
     ${Qt5Widgets_INCLUDE_DIRS}
     ${DtkWidget_INCLUDE_DIRS}
     ${DdeControlCenter_INCLUDE_DIR}
@@ -66,7 +62,7 @@
     ${Qt5DBus_INCLUDE_DIRS}
     ${KF5_QT_INCLUDE_DIRS}
     ${Qt5Network_INCLUDE_DIRS}
-#    ${DDE-Network-Core_INCLUDE_DIRS}
+    ${DDE-Network-Core_INCLUDE_DIRS}
 )
 
 # 设置目标要使用的链接库
@@ -81,7 +77,7 @@
     ${Qt5DBus_LIBRARIES}
     ${KF5_QT_LIBRARIES}
     ${Qt5Network_LIBRARIES}
-#    ${DDE-Network-Core_LIBRARIES}
+    ${DDE-Network-Core_LIBRARIES}
 )
 
 # 设置安装路径的前缀(默认为"/usr/local")

=== dock-example/CMakeLists.txt ===
--- 
+++ 
@@ -19,8 +19,6 @@
 aux_source_directory(../common-plugin COMMONPLUGINS)
 aux_source_directory(../common-plugin/widgets COMMONPLUGINWIDGET)
 aux_source_directory(../common-plugin/item COMMONPLUGINITEM)
-aux_source_directory(../src NETWORKDIR)
-aux_source_directory(../src/realize REALIZEDIR)
 aux_source_directory(. COMPILEFILES)
 file(GLOB_RECURSE QRCFILES "../common-plugin/network.qrc"
     "../common-plugin/resources/common/*.svg"
@@ -32,12 +30,10 @@
 
 add_executable(${PROJECT_NAME}
     ${COMPILEFILES}
-    ${NETWORKDIR}
     ${DOCKPLUGINDIR}
     ${COMMONPLUGINS}
     ${COMMONPLUGINWIDGET}
     ${COMMONPLUGINITEM}
-    ${REALIZEDIR}
     ${QRCFILES})
 
 get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
@@ -58,8 +54,6 @@
 )
 
 target_include_directories(${PROJECT_NAME} PUBLIC
-    ../src
-    ../src/realize
     ../dock-network-plugin
     ../common-plugin
     ../common-plugin/widgets
@@ -77,7 +71,9 @@
     ${QGSettings_INCLUDE_DIRS}
     ${LibNM_INCLUDE_DIRS}
     ${Qt5Network_INCLUDE_DIRS}
-    ${KF5_QT_INCLUDE_DIRS})
+    ${KF5_QT_INCLUDE_DIRS}
+    ${DDE-Network-Core_INCLUDE_DIRS}
+)
 
 target_link_libraries(${PROJECT_NAME} PRIVATE
     ${DdeControlCenter_LIBRARIES}
@@ -91,7 +87,9 @@
     ${Qt5DBus_LIBRARIES}
     ${Qt5Network_LIBRARIES}
     ${QGSettings_LIBRARIES}
-    ${KF5_QT_LIBRARIES})
+    ${KF5_QT_LIBRARIES}
+    ${DDE-Network-Core_LIBRARIES}
+)
 
 add_custom_command(
     OUTPUT path.pb.cc path.pb.h

=== dss-network-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # 启用 qrc 资源文件的支持
 set(CMAKE_AUTORCC ON)
 
-file(GLOB_RECURSE SRCS "*.h" "*.cpp"  "../src/*.h" "../src/*.cpp" "../common-plugin/*.h" "../common-plugin/*.cpp")
+file(GLOB_RECURSE SRCS "*.h" "*.cpp"  "../common-plugin/*.h" "../common-plugin/*.cpp")
 
 find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
 find_package(PkgConfig REQUIRED)
@@ -28,9 +28,6 @@
 add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
 add_library(${PLUGIN_NAME} SHARED ${SRCS} ../common-plugin/network.qrc)
 
-set(NETWORKINTERFACE "../src")
-list(REMOVE_ITEM NETWORKINTERFACE "utils.h")
-
 get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
 
 set(TRY_KF5_LIBRARIES
@@ -43,12 +40,11 @@
 endif()
 
 target_include_directories(${PLUGIN_NAME} PUBLIC
-    ${NETWORKINTERFACE}
     ${DtkWidget_INCLUDE_DIRS}
     ${Qt5DBus_INCLUDE_DIRS}
     ${DFrameworkDBus_INCLUDE_DIRS}
     ${QGSettings_INCLUDE_DIRS}
-    #${DDE-Network-Core_INCLUDE_DIRS}
+    ${DDE-Network-Core_INCLUDE_DIRS}
     ${DDESESSIONSHELL_INCLUDE_DIR}
     ${Qt5Network_INCLUDE_DIRS}
     ${KF5_QT_INCLUDE_DIRS}
@@ -61,7 +57,7 @@
     ${Qt5Svg_LIBRARIES}
     ${Qt5DBus_LIBRARIES}
     ${QGSettings_LIBRARIES}
-    #${DDE-Network-Core_LIBRARIES}
+    ${DDE-Network-Core_LIBRARIES}
     ${DFrameworkDBus_LIBRARIES}
     ${KF5_QT_LIBRARIES}
     ${Qt5Network_LIBRARIES}

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -67,3 +67,4 @@
 install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets LIBRARY DESTINATION lib)
 install(FILES ${CMAKE_BINARY_DIR}/dde-network-core.pc DESTINATION lib/pkgconfig)
 install(FILES ${INTERFACEFILES} DESTINATION include/libddenetworkcore)
+install(FILES ../config/org.deepin.dde.network.json DESTINATION share/dsg/configs/org.deepin.dde.network)

=== debian/changelog ===
dde-network-core (1.0.47-1) unstable; urgency=medium

  * update

 -- donghualin <donghualin@uniontech.com>  Mon, 27 Jun 2022 10:42:22 +0800

## dde-network-core 1.0.57

=== dde-network-dialog/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # 启用 qrc 资源文件的支持
 set(CMAKE_AUTORCC ON)
 
-file(GLOB_RECURSE SRCS "*.h" "*.cpp" "../src/*.h" "../src/*.cpp")
+file(GLOB_RECURSE SRCS "*.h" "*.cpp")
 
 find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
 find_package(PkgConfig REQUIRED)
@@ -26,9 +26,6 @@
 add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
 add_executable(${TARGET_NAME} ${SRCS} network.qrc)
 
-set(NETWORKINTERFACE "../src")
-list(REMOVE_ITEM NETWORKINTERFACE "utils.h")
-
 get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
 
 set(TRY_KF5_LIBRARIES
@@ -41,12 +38,11 @@
 endif()
 
 target_include_directories(${TARGET_NAME} PUBLIC
-    ${NETWORKINTERFACE}
     ${DtkWidget_INCLUDE_DIRS}
     ${Qt5DBus_INCLUDE_DIRS}
     ${DFrameworkDBus_INCLUDE_DIRS}
     ${QGSettings_INCLUDE_DIRS}
-    #${DDE-Network-Core_INCLUDE_DIRS}
+    ${DDE-Network-Core_INCLUDE_DIRS}
     ${Qt5Network_INCLUDE_DIRS}
     ${KF5_QT_INCLUDE_DIRS}
 )
@@ -57,7 +53,7 @@
     ${Qt5Svg_LIBRARIES}
     ${Qt5DBus_LIBRARIES}
     ${QGSettings_LIBRARIES}
-    #${DDE-Network-Core_LIBRARIES}
+    ${DDE-Network-Core_LIBRARIES}
     ${DFrameworkDBus_LIBRARIES}
     ${KF5_QT_LIBRARIES}
     ${Qt5Network_LIBRARIES}

=== dock-network-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # 启用 qrc 资源文件的支持
 set(CMAKE_AUTORCC ON)
 
-file(GLOB_RECURSE SRCS "*.h" "*.cpp" "item/*.h" "item/*.cpp" "../src/*.h" "../src/*.cpp" "../common-plugin/*.h" "../common-plugin/*.cpp")
+file(GLOB_RECURSE SRCS "*.h" "*.cpp" "item/*.h" "item/*.cpp" "../common-plugin/*.h" "../common-plugin/*.cpp")
 
 find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
 find_package(PkgConfig REQUIRED)
@@ -29,9 +29,6 @@
 add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
 add_library(${PLUGIN_NAME} SHARED ${SRCS} ../common-plugin/network.qrc)
 
-set(NETWORKINTERFACE "../src")
-list(REMOVE_ITEM NETWORKINTERFACE "utils.h")
-
 get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
 
 set(TRY_KF5_LIBRARIES
@@ -44,12 +41,11 @@
 endif()
 
 target_include_directories(${PLUGIN_NAME} PUBLIC
-    ${NETWORKINTERFACE}
     ${DtkWidget_INCLUDE_DIRS}
     ${Qt5DBus_INCLUDE_DIRS}
     ${DFrameworkDBus_INCLUDE_DIRS}
     ${QGSettings_INCLUDE_DIRS}
-    #${DDE-Network-Core_INCLUDE_DIRS}
+    ${DDE-Network-Core_INCLUDE_DIRS}
     ${DDE_DOCK_INCLUDE_DIR}
     ${Qt5Network_INCLUDE_DIRS}
     ${KF5_QT_INCLUDE_DIRS}
@@ -62,7 +58,7 @@
     ${Qt5Svg_LIBRARIES}
     ${Qt5DBus_LIBRARIES}
     ${QGSettings_LIBRARIES}
-    #${DDE-Network-Core_LIBRARIES}
+    ${DDE-Network-Core_LIBRARIES}
     ${DFrameworkDBus_LIBRARIES}
     ${KF5_QT_LIBRARIES}
     ${Qt5Network_LIBRARIES}

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -18,35 +18,48 @@
 
 pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
 pkg_check_modules(QGSettings REQUIRED gsettings-qt)
+pkg_check_modules(LibNM REQUIRED IMPORTED_TARGET libnm)
 
-get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
+# KF5 network manager
+ get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
 
-set(TRY_KF5_LIBRARIES
-IMPORTED_LOCATION_DEBIAN
-IMPORTED_LOCATION_NOCONFIG
-)
+ set(TRY_KF5_LIBRARIES
+ IMPORTED_LOCATION_DEBIAN
+ IMPORTED_LOCATION_NOCONFIG
+ )
 
-if (NOT KF5_QT_LIBRARIES)
-    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
-endif()
+ foreach(LETTER ${TRY_KF5_LIBRARIES})
+     if (NOT KF5_QT_LIBRARIES)
+         get_target_property(KF5_QT_LIBRARIES KF5::NetworkManagerQt ${LETTER})
+     endif()
+ endforeach()
+
+ if (NOT KF5_QT_LIBRARIES)
+     find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
+ endif()
+ # end KF5 network manager
 
 target_include_directories(${PROJECT_NAME} PUBLIC
     realize
     ${Qt5DBus_INCLUDE_DIRS}
     ${DFrameworkDBus_INCLUDE_DIRS}
     ${QGSettings_INCLUDE_DIRS}
-    ${LibNM_INCLUDE_DIRS}
     ${Qt5Network_INCLUDE_DIRS}
-    ${KF5_QT_INCLUDE_DIRS})
+    ${KF5_QT_INCLUDE_DIRS}
+    PkgConfig::LibNM
+)
+
+message(STATUS ${LibNM_INCLUDE_DIRS})
 
 target_link_libraries(${PROJECT_NAME} PRIVATE
     ${Qt5Core_LIBRARIES}
-    ${LibNM_LIBRARIES}
     ${DFrameworkDBus_LIBRARIES}
     ${Qt5DBus_LIBRARIES}
     ${Qt5Network_LIBRARIES}
     ${QGSettings_LIBRARIES}
-    ${KF5_QT_LIBRARIES})
+    ${KF5_QT_LIBRARIES}
+    PkgConfig::LibNM
+)
 
 configure_file(dde-network-core.pc.in ../dde-network-core.pc @ONLY)

=== debian/changelog ===
dde-network-core (1.0.57-1) unstable; urgency=medium

  * update

 -- donghualin <donghualin@uniontech.com>  Sat, 13 Aug 2022 14:10:38 +0800

## dde-network-core 1.0.61

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,64 @@
 set(DDE-Network-Core_INCLUDE_DIRS  "${CMAKE_SOURCE_DIR}/src")
 set(DDE-Network-Core_LIBRARIES  dde-network-core)
 
+find_package(PkgConfig REQUIRED)
+find_package(KF5NetworkManagerQt REQUIRED)
+pkg_check_modules(LibNM REQUIRED IMPORTED_TARGET libnm)
+include_directories(${LibNM_INCLUDE_DIRS})
+
+pkg_check_modules(Gio REQUIRED gio-2.0)
+include_directories(${Gio_INCLUDE_DIRS})
+
+pkg_search_module(GLIB REQUIRED glib-2.0)
+include_directories(${GLIB_INCLUDE_DIRS})
+link_directories(${GLIB_LIBRARY_DIRS})
+
+set(TRY_KF5_LIBRARIES
+IMPORTED_LOCATION_DEBIAN
+IMPORTED_LOCATION_NOCONFIG
+)
+
+if (NOT KF5_QT_LIBRARIES)
+    find_library(KF5_QT_LIBRARIES libKF5NetworkManagerQt.so)
+endif()
+
+find_package(Qt5 COMPONENTS Core Widgets DBus Network LinguistTools REQUIRED)
+find_package(KF5NetworkManagerQt REQUIRED)
+get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
+
+# test networkmanagetqt
+try_compile(DEEPIN_NMQT_TEST
+              ${CMAKE_CURRENT_BINARY_DIR}/try_compile
+            SOURCES
+              ${CMAKE_CURRENT_SOURCE_DIR}/try-compile/networkmanagerqt.cc
+            LINK_LIBRARIES
+              ${KF5_QT_LIBRARIES}
+              Qt5::Core
+              Qt5::DBus
+              Qt5::Network
+            CMAKE_FLAGS
+              "-DINCLUDE_DIRECTORIES=${KF5_QT_INCLUDE_DIRS}\;${GLIB_INCLUDE_DIRS}\;${LibNM_INCLUDE_DIRS}"
+            OUTPUT_VARIABLE
+              result
+)
+
+if (QT_DEBUG)
+    message(" KF5_QT_INCLUDE_DIRS : " ${KF5_QT_INCLUDE_DIRS})
+    message(" GLIB_INCLUDE_DIRS :" ${GLIB_INCLUDE_DIRS})
+    message(" CMAKE_CURRENT_SOURCE_DIR: " ${CMAKE_CURRENT_SOURCE_DIR})
+    message(STATUS ${result})
+endif()
+
+if (DEEPIN_NMQT_TEST)
+    add_definitions(-DUSE_DEEPIN_NMQT)
+endif()
+
+message(STATUS DEEPIN_NMQT_TEST ": ${DEEPIN_NMQT_TEST}")
+
+if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
+    set(CMAKE_INSTALL_PREFIX "/usr")
+endif()
+
 add_subdirectory("src")
 add_subdirectory("dcc-network-plugin")
 add_subdirectory("tests")

=== dde-network-dialog/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(TARGET_NAME "dde-network-dialog")
 
 project(${TARGET_NAME})
-
+include(GNUInstallDirs)
 # 启用 qt moc 的支持
 set(CMAKE_AUTOMOC ON)
 # 启用 qrc 资源文件的支持
@@ -59,6 +59,6 @@
     ${Qt5Network_LIBRARIES}
 )
 
-install(TARGETS ${TARGET_NAME} DESTINATION /usr/bin)
+install(TARGETS ${TARGET_NAME} DESTINATION bin)
 # 安装 .qm 文件
-install(FILES ${QM_FILES} DESTINATION /usr/share/${TARGET_NAME}/translations)
+install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${TARGET_NAME}/translations)

=== dock-network-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(PLUGIN_NAME "dock-network-plugin")
 
 project(${PLUGIN_NAME})
-
+include(GNUInstallDirs)
 # 启用 qt moc 的支持
 set(CMAKE_AUTOMOC ON)
 # 启用 qrc 资源文件的支持
@@ -64,6 +64,6 @@
     ${Qt5Network_LIBRARIES}
 )
 
-install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION /usr/lib/dde-dock/plugins/system-trays)
+install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/system-trays)
 # 安装 .qm 文件
-install(FILES ${QM_FILES} DESTINATION /usr/share/${PLUGIN_NAME}/translations)
+install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PLUGIN_NAME}/translations)

=== dss-network-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 project(${PLUGIN_NAME})
 
+include(GNUInstallDirs)
 # 启用 qt moc 的支持
 set(CMAKE_AUTOMOC ON)
 # 启用 qrc 资源文件的支持
@@ -63,7 +64,8 @@
     ${Qt5Network_LIBRARIES}
 )
 
-install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION /lib/dde-session-shell/modules)
+install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-session-shell/modules)
 # 安装 .qm 文件
-install(FILES ${QM_FILES} DESTINATION /usr/share/${PLUGIN_NAME}/translations)
-install(FILES 10-network-manager.pkla DESTINATION /var/lib/polkit-1/localauthority/10-vendor.d)
+install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PLUGIN_NAME}/translations)
+
+install(FILES 10-network-manager.pkla DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/polkit-1/localauthority/10-vendor.d)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 
+include(GNUInstallDirs)
 set(CMAKE_PREFIX_PATH $ENV{Qt5_DIR})
 
 file(GLOB_RECURSE SOURCEFILES "*.h" "*.cpp")
@@ -75,9 +76,7 @@
     wireddevice.h
     wirelessdevice.h)
 
-set(CMAKE_INSTALL_PREFIX "/usr")
-
-install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets LIBRARY DESTINATION lib)
-install(FILES ${CMAKE_BINARY_DIR}/dde-network-core.pc DESTINATION lib/pkgconfig)
-install(FILES ${INTERFACEFILES} DESTINATION include/libddenetworkcore)
-install(FILES ../config/org.deepin.dde.network.json DESTINATION share/dsg/configs/org.deepin.dde.network)
+install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
+install(FILES ${CMAKE_BINARY_DIR}/dde-network-core.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+install(FILES ${INTERFACEFILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libddenetworkcore)
+install(FILES ../config/org.deepin.dde.network.json DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dsg/configs/org.deepin.dde.network)

=== debian/changelog ===
dde-network-core (1.0.61-1) unstable; urgency=medium

  * update

 -- donghualin <donghualin@uniontech.com>  Sat, 27 Aug 2022 10:37:28 +0800

=== debian/control ===
--- 
+++ 
@@ -29,30 +29,30 @@
 
 Package: libdde-network-core-dev
 Architecture: any
-Depends: ${misc:Depends},${shlibs:Depends},
+Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
 Description: the interface of networkcode,used for developers
  libdde-network-core-dev module
 
 Package: dcc-network-plugin
 Architecture: any
-Depends: ${misc:Depends},${shlibs:Depends},
+Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
 Description: the plugin of network for dde control center
  dcc-network-plugin module
 
 Package: dock-network-plugin
 Architecture: any
-Depends: ${misc:Depends},${shlibs:Depends},
+Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
 Description: the plugin of network for dde-dock
  dock-plugin module
 
 Package: dde-network-dialog
 Architecture: any
-Depends: ${misc:Depends},${shlibs:Depends},
+Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
 Description: the executable of network
  dde-network-dialog module
 
 Package: dss-network-plugin
 Architecture: any
-Depends: ${misc:Depends},${shlibs:Depends},
+Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
 Description: the plugin of network for dde-lock
  dss-network-plugin module

## dde-network-core 1.0.64

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,10 +2,12 @@
 
 project(dde-network-core)
 
+set(VERSION "1.0.0" CACHE STRING "define project version")
+
 # 增加安全编译参数
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
-set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")
+set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -z relro -z now -z noexecstack -pie")
 
 set(DDE-Network-Core_INCLUDE_DIRS  "${CMAKE_SOURCE_DIR}/src")
 set(DDE-Network-Core_LIBRARIES  dde-network-core)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -39,10 +39,8 @@
 )
 
 aux_source_directory(. FILES)
-aux_source_directory(../src NETWORKDIR)
-aux_source_directory(../src/realize REALIZEDIR)
 
-add_executable(${PROJECT_NAME} ${FILES} ${NETWORKDIR} ${REALIZEDIR})
+add_executable(${PROJECT_NAME} ${FILES})
 
 target_include_directories(${PROJECT_NAME} PUBLIC
     ${DFrameworkDBus_INCLUDE_DIRS}
@@ -66,4 +64,6 @@
     ${QGSettings_LIBRARIES}
     ${KF5_QT_LIBRARIES}
     -lpthread
-    -lm)
+    -lm
+    dde-network-core
+)

=== debian/changelog ===
dde-network-core (1.0.64-1) unstable; urgency=medium

  * update

 -- donghualin <donghualin@uniontech.com>  Thu, 15 Sep 2022 13:08:13 +0800

## dde-network-core 1.0.69

=== dcc-network-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 project(${PLUGIN_NAME})
 
+include(GNUInstallDirs)
 # 启用 qt moc 的支持
 set(CMAKE_AUTOMOC ON)
 # 启用 qrc 资源文件的支持
@@ -80,11 +81,8 @@
     ${DDE-Network-Core_LIBRARIES}
 )
 
-# 设置安装路径的前缀(默认为"/usr/local")
-set(CMAKE_INSTALL_PREFIX "/usr")
-
 # 设置执行 make install 时哪个目标应该被 install 到哪个位置
 install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-control-center/modules)
 
 # 安装 .qm 文件
-install(FILES ${QM_FILES} DESTINATION share/${PLUGIN_NAME}/translations)
+install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PLUGIN_NAME}/translations)

=== dde-network-dialog/CMakeLists.txt ===
--- 
+++ 
@@ -59,6 +59,6 @@
     ${Qt5Network_LIBRARIES}
 )
 
-install(TARGETS ${TARGET_NAME} DESTINATION bin)
+install(TARGETS ${TARGET_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
 # 安装 .qm 文件
-install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${TARGET_NAME}/translations)
+install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${TARGET_NAME}/translations)

=== dss_example/CMakeLists.txt ===
--- 
+++ 
@@ -21,8 +21,6 @@
 aux_source_directory(../common-plugin COMMONPLUGINS)
 aux_source_directory(../common-plugin/widgets COMMONPLUGINWIDGET)
 aux_source_directory(../common-plugin/item COMMONPLUGINITEM)
-aux_source_directory(../src NETWORKDIR)
-aux_source_directory(../src/realize REALIZEDIR)
 aux_source_directory(. COMPILEFILES)
 
 get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
@@ -57,8 +55,6 @@
 )
 
 target_include_directories(${PROJECT_NAME} PUBLIC
-    ../src
-    ../src/realize
     ../dss-network-plugin
     ../common-plugin
     ../common-plugin/widgets
@@ -74,7 +70,9 @@
     ${QGSettings_INCLUDE_DIRS}
     ${LibNM_INCLUDE_DIRS}
     ${Qt5Network_INCLUDE_DIRS}
-    ${KF5_QT_INCLUDE_DIRS})
+    ${KF5_QT_INCLUDE_DIRS}
+    ${DDE-Network-Core_INCLUDE_DIRS}
+)
 
 target_link_libraries(${PROJECT_NAME} PRIVATE
     ${DdeControlCenter_LIBRARIES}
@@ -88,7 +86,9 @@
     ${Qt5DBus_LIBRARIES}
     ${Qt5Network_LIBRARIES}
     ${QGSettings_LIBRARIES}
-    ${KF5_QT_LIBRARIES})
+    ${KF5_QT_LIBRARIES}
+    ${DDE-Network-Core_LIBRARIES}
+)
 
 add_custom_command(
     OUTPUT path.pb.cc path.pb.h

=== debian/changelog ===
dde-network-core (1.0.69-1) unstable; urgency=medium

  * update

 -- donghualin <donghualin@uniontech.com>  Thu, 13 Oct 2022 19:39:49 +0800

## dde-network-core 1.1.2

=== dss-network-plugin/CMakeLists.txt ===
--- 
+++ 
@@ -66,6 +66,6 @@
 
 install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-session-shell/modules)
 # 安装 .qm 文件
-install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PLUGIN_NAME}/translations)
+install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${PLUGIN_NAME}/translations)
 
 install(FILES 10-network-manager.pkla DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/polkit-1/localauthority/10-vendor.d)

=== debian/changelog ===
dde-network-core (1.1.2-1) unstable; urgency=medium

  * update

 -- donghualin <donghualin@uniontech.com>  Thu, 10 Nov 2022 10:39:43 +0800

## dde-network-core 1.1.4

=== dock-example/CMakeLists.txt ===
--- 
+++ 
@@ -16,25 +16,22 @@
 find_package(DdeDock REQUIRED)
 
 aux_source_directory(../dock-network-plugin DOCKPLUGINDIR)
-aux_source_directory(../common-plugin COMMONPLUGINS)
-aux_source_directory(../common-plugin/widgets COMMONPLUGINWIDGET)
-aux_source_directory(../common-plugin/item COMMONPLUGINITEM)
+aux_source_directory(../common-plugin/* COMMONPLUGINS)
+
 aux_source_directory(. COMPILEFILES)
-file(GLOB_RECURSE QRCFILES "../common-plugin/network.qrc"
-    "../common-plugin/resources/common/*.svg"
-    "../common-plugin/resources/wired/*.svg"
-    "../common-plugin/resources/wireless/*.svg"
-    "../common-plugin/resources/wireless6/*.svg")
 
 get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
 
+file(GLOB_RECURSE COMMONPLUGINS_SRCS
+    ../common-plugin/*
+    ../dss-network-plugin/dockpopupwindow.h
+    ../dss-network-plugin/dockpopupwindow.cpp
+)
 add_executable(${PROJECT_NAME}
     ${COMPILEFILES}
     ${DOCKPLUGINDIR}
-    ${COMMONPLUGINS}
-    ${COMMONPLUGINWIDGET}
-    ${COMMONPLUGINITEM}
-    ${QRCFILES})
+    ${COMMONPLUGINS_SRCS}
+    )
 
 get_target_property(KF5_QT_INCLUDE_DIRS KF5::NetworkManagerQt INTERFACE_INCLUDE_DIRECTORIES)
 
@@ -61,6 +58,7 @@
     ../common-plugin/resources/common/
     ../common-plugin/resources/wired/
     ../common-plugin/resources/wireless/
+    ../dss-network-plugin
     ${DdeControlCenter_INCLUDE_DIR}
     ${DDE_DOCK_INCLUDE_DIR}
     ${DtkWidget_INCLUDE_DIRS}

=== debian/changelog ===
dde-network-core (1.1.4-1) unstable; urgency=medium

  * update

 -- donghualin <donghualin@uniontech.com>  Fri, 25 Nov 2022 13:21:51 +0800

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
                libgsettings-qt-dev,
                pkg-config,
                qtbase5-dev,
+               qtbase5-private-dev,
                qttools5-dev-tools,
                libgtest-dev,
                libkf5networkmanagerqt-dev,
@@ -45,12 +46,6 @@
 Description: the plugin of network for dde-dock
  dock-plugin module
 
-Package: dde-network-dialog
-Architecture: any
-Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
-Description: the executable of network
- dde-network-dialog module
-
 Package: dss-network-plugin
 Architecture: any
 Depends: ${misc:Depends},${shlibs:Depends},libdde-network-core (= ${binary:Version})
